#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>
#include <stdlib.h>
#include <math.h> 

#include <lv2/sysfs.h>

#include "ps3graph.c"
int nbjoysticks;

char DSKPATH[]="/dev_hdd0/HOMEBREW/amstrad";
char DSKPATHV[]="/dev_hdd0/HOMEBREW/amstrad/%s";

char ndsk[400][MAXPATHLEN+1];
int ndsknum=0;

SDL_Surface *gui_surface = NULL;

 int kmousex=0,kmousey=0;

//K7
int isK7(char d_name[], int d_namlen){
/*
	char suffix[4];
	int len=d_namlen;

	if(len>3){

		sprintf(suffix,"%c%c%c",d_name[len-3],d_name[len-2],d_name[len-1]);
		if(strcmp (suffix,"cdt") == 0 || strcmp (suffix,"CDT") == 0 )return 1;
		else return 0;
	}
*/
	return 0;

}
//D7
int isDSK(char d_name[], int d_namlen){

	char suffix[4];
	int len=d_namlen;

	if(len>4){

		sprintf(suffix,"%c%c%c%c",d_name[len-4],d_name[len-3],d_name[len-2],d_name[len-1]);
		if(strcmp (suffix,".dsk") == 0 || strcmp (suffix,".DSK") == 0 )return 1;
		else return 0;
	}

	return 0;
}

int Fs_ReadDir(const char *source){

	s32 fd;
	sysFSDirent entry;

	int ret;

	/* Open directory */
	ret = sysFsOpendir(source, &fd);
	if (ret)
		return ret;

	/* Read directory */
	while (1) {
		unsigned long read;

		/* Read entry */
		ret = sysFsReaddir(fd, &entry, &read);
		if (ret || !read)
			break;

		/* Ignore dot entries */
		if (entry.d_name[0] == '.')
			continue;

		if ( !isDSK(entry.d_name,entry.d_namlen) && !isK7(entry.d_name,entry.d_namlen) )
			continue;

		
		if (entry.d_type == 1) {
			//dir
		} else {
			 strcpy(ndsk[ndsknum],entry.d_name);
			 ndsknum++;
		}
		
	}

	/* Close directory */
	sysFsClosedir(fd);

	return ret;
}

void romlist(){

	Fs_ReadDir(DSKPATH);

}

SDL_Joystick * joy ;
Sint16 x_move, y_move;
Uint8 but1,but2,bouton[16];
Sint16 Rx_move, Ry_move;

enum axenaame {
 A_L_H=0,
 A_L_V,
 A_R_H,
 A_R_V
};

enum butname {
BLEFT=0, 
BDOWN,
BRIGHT, 
BUP, 
BSTART,
BR3, 
BL3,
BSELECT,
BSQUARE,
BCROSS,
BCIRCLE,
BTRIANGLE,
BR1,
BL1,
BR2,
BL2
};

int initjoy(){

	int i;

	/* Initialise SDL's joystick subsystem: */
	if (SDL_InitSubSystem(SDL_INIT_JOYSTICK) < 0)
	{
		//Log_Printf(LOG_ERROR, "Could not init joysticks: %s\n", SDL_GetError());
		return 1;
	}


     nbjoysticks = SDL_NumJoysticks();
     printf("Nombres de joysticks attachés: %d\n\n", nbjoysticks);

     for (i = 0; i < nbjoysticks; i++)
     {
	  joy = SDL_JoystickOpen(i);/*
	  printf("Joystick s\n", i, SDL_JoystickName(i));
	  printf("Axes: %d\n", SDL_JoystickNumAxes(joy));
	  printf("Boutons: %d\n", SDL_JoystickNumButtons(joy));
	  printf("Trackballs: %d\n", SDL_JoystickNumBalls(joy));
	  printf("Chapeaux: %d\n\n", SDL_JoystickNumHats(joy));*/
     }

     romlist();

	gui_surface = SDL_CreateRGBSurface(SDL_SWSURFACE,CPC_VISIBLE_SCR_WIDTH*2,CPC_VISIBLE_SCR_HEIGHT*2,32,
		video_surface->format->Rmask,
		video_surface->format->Gmask,
		video_surface->format->Bmask,
		video_surface->format->Amask);

     return 0;
}

#define MUP 	1
#define MDOWN   2
#define MLEFT   4
#define MRIGHT  8
#define MOK    16   
#define MCANCEL 32

#define JOYRANGE_UP_VALUE     -16384     
#define JOYRANGE_DOWN_VALUE    16383
#define JOYRANGE_LEFT_VALUE   -16384
#define JOYRANGE_RIGHT_VALUE   16383

#define DECX 232 // 768/2 - (38*8)/2


Uint8 joykey[6]={0,0,0,0,0,0};
Uint8 joykbd[6]={0,0,0,0,0,0};

Uint8 sysbut[8]={0,0,0,0,0,0,0,0};

bool SHIFTON=0,VKBD=0,CHGDSK=0,CRESET=0,CQUIT=0,DBG=0,TYPE_CAT=0,TYPE_RUN=0,TYPE_ENTER=0,TYPE_DEL=0;


	
static char nameKeys[15*5][5] =  {
     
            {"ESC\0"},{" 1"},{" 2"},{" 3"},{" 4"},{" 5"},{" 6"},{" 7"},{" 8"},{" 9"},{" 0"},{" -"},{" Clr"},{"DEL"},{"F7"},
            {"Tab\0"},{" Q"},{" W"},{" E"},{" R"},{" T"},{" Y"},{" U"},{" I"},{" O"},{" P"},{" @"},{" ["},{"Ent"},{" F4"},
            {"Cps\0"},{" A"},{" S"},{" D"},{" F"},{" G"},{" H"},{" J"},{" K"},{" L"},{" :"},{" ;"}, {" ]"},{" F1"},{" F2"},
            {"Shf\0"},{" Z"},{" X"},{" C"},{" V"},{" B"},{" N"},{" M"},{" ,"},{" ."},{" /"},{" \\"},{" F3"},{" F5"},{" F6"},
            {" Ctl"},{"Cop"},{"spc"},{"Lat"},{"LFT"},{" UP"},{"RGH"},{"DWN"},{"NP."},{"Spc"},{"INS"},{"RAt"},{" F8"},{" F9"},{" F0"}       
  
    };

	
static char namesSHFTKeys[15*5][5] =  {
     
            {"ESC\0"},{" !"},{" \""},{" #"},{" $"},{" %"},{" &"},{" '"},{" ("},{" )"},{" _"},{" £"},{" Clr"},{"DEL"},{"F7"},
            {"Tab\0"},{" Q"},{" W"},{" E"},{" R"},{" T"},{" Y"},{" U"},{" I"},{" O"},{" P"},{" |"},{" {"},{"Ent"},{" F4"},
            {"Cps\0"},{" A"},{" S"},{" D"},{" F"},{" G"},{" H"},{" J"},{" K"},{" L"},{" *"},{" +"}, {" }"},{" F1"},{" F2"},
            {"Shf\0"},{" Z"},{" X"},{" C"},{" V"},{" B"},{" N"},{" M"},{" <"},{" >"},{" ?"},{" `"},{" F3"},{" F5"},{" F6"},
            {" Ctl"},{"Cop"},{"spc"},{"Lat"},{"LFT"},{" UP"},{"RGH"},{"DWN"},{"NP."},{"Spc"},{"INS"},{"RAt"},{" F8"},{" F9"},{" F0"}       
  
    };

Uint8 ValKeys[5*15] =                     
    {
	   0x82,0x80,0x81,0x71,0x70,0x61,0x60,0x51,0x50,0x41,0x40,0x31,0x20,0x97,0x12 ,
	
	   0x84,0x83,0x73,0x72,0x62,0x63,0x53,0x52,0x43,0x42,0x33,0x14,0x32,0x22,0x24 ,
	
	   0x86,0x85,0x74,0x75,0x65,0x64,0x54,0x55,0x45,0x44,0x34,0x35,0x21,0x15,0x16 ,
	
	   0x25,0x87,0x77,0x76,0x67,0x66,0x56,0x46,0x37,0x47,0x36,0x25,0x05,0x14,0x04 ,

	   0x27,0x11,0x57,0x11,0x10,0x00,0x01,0x02,0x07,0x57,0x20,0x26,0x13,0x03,0x17 
	
    };

Uint8 vkey=0xff;

Uint8 check_vkey2()
{
 int x,y;
 //check which key is press
 
  for(x=0;x<15;x++)
     for(y=0;y<5;y++)        
       	if(kmousex==x && kmousey==y )   
			return  ValKeys[y*15 + x];    

 // if not pressed return nop    
 return 0xff;
}

// ps3 lame joy event check
#define WAIT 240

int cmd_cpt=0;
static long prgframe=0;

void joystick_key(){

	Uint8 nData = 0;
        int i,cpc_key;
	

	 x_move=0;
	 y_move=0;
    	 but1=0;
         but2=0;

	x_move=SDL_JoystickGetAxis(joy,A_L_H);
	y_move=SDL_JoystickGetAxis(joy,A_L_V);
        Rx_move=SDL_JoystickGetAxis(joy,A_R_H);
	Ry_move=SDL_JoystickGetAxis(joy,A_R_V);

	for(i=0;i<16;i++)bouton[i]=SDL_JoystickGetButton(joy,i);

	but1=bouton[BCROSS];
	but2=bouton[BSQUARE];

	prgframe++;

       if(bouton[BLEFT] && prgframe%WAIT==1 /*&& joykbd[0]==0*/){
		joykbd[0]=1;
		kmousex--;if(kmousex<0)kmousex=0;
        }
       else if( !(bouton[BLEFT]) && joykbd[0]==1){
		joykbd[0]=0;
	}

       if(bouton[BDOWN] && prgframe%WAIT==1 /*&& joykbd[1]==0*/){
		joykbd[1]=1;
		kmousey++;if(kmousey>=5)kmousey=4;
        }
       else if( !(bouton[BDOWN]) && joykbd[1]==1){
		joykbd[1]=0;
	}

       if(bouton[BRIGHT] && prgframe%WAIT==1 /*&& joykbd[2]==0*/){
		joykbd[2]=1;
		kmousex++;if(kmousex>=15)kmousex=14;
        }
       else if( !(bouton[BRIGHT]) && joykbd[2]==1){
		joykbd[2]=0;
	}

       if(bouton[BUP] && prgframe%WAIT==1 /*&& joykbd[3]==0*/){
		joykbd[3]=1;
		kmousey--;if(kmousey<0)kmousey=0;
        }
       else if( !(bouton[BUP]) && joykbd[3]==1){
		joykbd[3]=0;
	}

       if(bouton[BR1] && joykbd[4]==0){
		joykbd[4]=1;
		VKBD=!VKBD;
        }
       else if( !(bouton[BR1]) && joykbd[4]==1){
		joykbd[4]=0;
	}

       if(bouton[BR2] && joykbd[5]==0){
		joykbd[5]=1;	

		if(VKBD)vkey=check_vkey2();
		else  vkey=0xff;

		if(vkey==0x25)//RSHIFT
            	{
                      SHIFTON ^=1;                        
                      if(SHIFTON)keyboard_matrix[vkey >> 4] &= ~bit_values[vkey & 7];
		      else keyboard_matrix[vkey >> 4] |= bit_values[vkey & 7];
		      vkey=0xff;
                }

		if(vkey!=0xff && vkey!=0x25)keyboard_matrix[vkey >> 4] &= ~bit_values[vkey & 7];// key is being held down

        }
        else if( !(bouton[BR2]) && joykbd[5]==1){
		joykbd[5]=0;
		if(vkey!=0xff && vkey!=0x25 )keyboard_matrix[vkey >> 4] |= bit_values[vkey & 7]; // key has been released
	}

//sysbut
        if(bouton[BSTART] && sysbut[0]==0){
		sysbut[0]=1;
		CRESET=!CRESET;
        }
        else if( !(bouton[BSTART]) && sysbut[0]==1){
		sysbut[0]=0;
	}

       if(bouton[BSELECT] && sysbut[1]==0){
		sysbut[1]=1;
		CQUIT=!CQUIT;
        }
        else if( !(bouton[BSELECT]) && sysbut[1]==1){
		sysbut[1]=0;
	}

       if(bouton[BL1] && sysbut[2]==0){
		sysbut[2]=1;
		CHGDSK=!CHGDSK;
        }
        else if( !(bouton[BL1]) && sysbut[2]==1){
		sysbut[2]=0;
	}

       if(bouton[BL2] && sysbut[3]==0){
		sysbut[3]=1;
		TYPE_CAT=!TYPE_CAT; 
		if(TYPE_CAT)cmd_cpt=0;	
		
        }
        else if( !(bouton[BL2]) && sysbut[3]==1){
		sysbut[3]=0;
	}

 	if(bouton[BL3] && sysbut[4]==0){
		sysbut[4]=1;
		TYPE_RUN=!TYPE_RUN; 
		if(TYPE_RUN)cmd_cpt=0;	
		
        }
       else if( !(bouton[BL3]) && sysbut[4]==1){
		sysbut[4]=0;
	}

	if(bouton[BR3] && sysbut[5]==0){
		sysbut[5]=1;
		DBG=!DBG;	
		if(DBG)audio_resume();
		else audio_pause();
        }
        else if( !(bouton[BR3]) && sysbut[5]==1){
		sysbut[5]=0;
	}

        if(bouton[BCIRCLE] && sysbut[6]==0){
		sysbut[6]=1;
		TYPE_ENTER=!TYPE_ENTER; 
		if(TYPE_ENTER)cmd_cpt=0;	
		
        }
       else if( !(bouton[BCIRCLE]) && sysbut[6]==1){
		sysbut[6]=0;
	}

 	if(bouton[BTRIANGLE] && sysbut[7]==0){
		sysbut[7]=1;
		TYPE_DEL=!TYPE_DEL; 
		if(TYPE_DEL)cmd_cpt=0;	
		
        }
       else if( !(bouton[BTRIANGLE]) && sysbut[7]==1){
		sysbut[7]=0;
	}
    


	if(but1)nData |=MOK;
	if(but2)nData |=MCANCEL;

	/* Directions */
	if (y_move <= JOYRANGE_UP_VALUE)
		nData |= MUP;
	else if (y_move >= JOYRANGE_DOWN_VALUE)
		nData |= MDOWN;
	if (x_move <= JOYRANGE_LEFT_VALUE)
		nData |= MLEFT;
	else if (x_move >= JOYRANGE_RIGHT_VALUE)
		nData |= MRIGHT;

      if(nData & MUP && joykey[0]==0){
		cpc_key=0x90;
		joykey[0]=1;
		keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // key is being held down
      }
      else if( !(nData & MUP) && joykey[0]==1){
		joykey[0]=0;cpc_key=0x90;
		keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7]; // key has been released
      }

      if(nData & MDOWN && joykey[1]==0){
		cpc_key=0x91;
		joykey[1]=1;
		keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // key is being held down
      }
      else if( !(nData & MDOWN) && joykey[1]==1){
		joykey[1]=0;cpc_key=0x91;
		keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7]; // key has been released
      }

      if(nData & MLEFT && joykey[2]==0){
		cpc_key=0x92;
		joykey[2]=1;
		keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // key is being held down
      }
      else if( !(nData & MLEFT) && joykey[2]==1){
		joykey[2]=0;cpc_key=0x92;
		keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7]; // key has been released
      }

      if(nData & MRIGHT && joykey[3]==0){
		cpc_key=0x93;
		joykey[3]=1;
		keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // key is being held down
      }
      else if( !(nData & MRIGHT) && joykey[3]==1){
		joykey[3]=0;cpc_key=0x93;
		keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7]; // key has been released
      }

      if(nData & MOK && joykey[4]==0){
		cpc_key=0x94;
		joykey[4]=1;
		keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // key is being held down
      }
      else if( !(nData & MOK) && joykey[4]==1){
		joykey[4]=0;cpc_key=0x94;
		keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7]; // key has been released
      }

      if(nData & MCANCEL && joykey[5]==0){
		cpc_key=0x95;
		joykey[5]=1;
		keyboard_matrix[cpc_key >> 4] &= ~bit_values[cpc_key & 7]; // key is being held down
      }
      else if( !(nData & MCANCEL) && joykey[5]==1){
		joykey[5]=0;cpc_key=0x95;
		keyboard_matrix[cpc_key >> 4] |= bit_values[cpc_key & 7]; // key has been released
      }

}



#define XBASE 204+4
#define YBASE 256+148
#define XBASE2 204
#define YBASE2 256+142

#define DrawBoxL( x,y,z,w,h,col) drawrect( (x),(y),(x) + (w),(y)+(h),col)
#define DrawBoxF( x,y,z,w,h,col) putrect ( (x),(y),(col),(w),(h))

void virtual_kdb()
{
	int y,x;     	
      
	SDL_FillRect(gui_surface, NULL, 0x00000000);

	DrawBoxF(XBASE2,YBASE2,0.5,360,80,SDL_MapRGBA(gui_surface->format,0x43, 0x8b, 0xff,0x45));

 	for(x=0;x<15;x++){
     		for(y=0;y<5;y++){
			DrawBoxL( XBASE2+x*24,YBASE2+y*16,0.4,24,16,0xffffffff);
			if(!SHIFTON)textpixel(XBASE-2+x*24 ,YBASE+16*y,0xffffffff,0,1,nameKeys[(y*15)+x]);   
			else textpixel(XBASE-2+x*24 ,YBASE+16*y,0xffffffff,0,1,namesSHFTKeys[(y*15)+x]); 
  		}
	 }	 
 	
	DrawBoxL( XBASE2+kmousex*24,YBASE2+kmousey*16,0,24,16,0xFFFF0000);

}

//load dsk menu

char * SelectDsk(){

    int i,j,select=0,fselect=0,pselect=0;	
    static int padcountdown = 0;
    static int pad_held_down = 0;
    static char seldsk[128];

    SDL_Event event;
    Uint8 nData = 0;

    x_move=0;
    y_move=0;
    but1=0;
    but2=0;
    
   if (DBG) {
      audio_pause();
   }

    while(1){

	if(padcountdown) padcountdown--;

	nData = 0;

     	while (SDL_PollEvent(&event))
     	{
       
		switch (event.type)
		{
       			case SDL_KEYDOWN:
                	case SDL_KEYUP:
				if ( event.key.keysym.sym == SDLK_ESCAPE )return ;		
	       			break;
	  		default:
	       		break;
         	}
      	}

	//read ps3joy axis  & but cross & square

	x_move=SDL_JoystickGetAxis(joy, 0);
	y_move=SDL_JoystickGetAxis(joy, 1);
	but1=SDL_JoystickGetButton(joy, 9);
	but2=SDL_JoystickGetButton(joy, 8);
	
	if(but1)nData |=MOK;
 	if(but2)nData |=MCANCEL;

	if(nData & MCANCEL){

		if (DBG) {
      			audio_resume();
   		}
		return "";
	}

		/* Directions */
		if (y_move <= JOYRANGE_UP_VALUE)
			nData |= MUP;
		else if (y_move >= JOYRANGE_DOWN_VALUE)
			nData |= MDOWN;
		if (x_move <= JOYRANGE_LEFT_VALUE)
			nData |= MLEFT;
		else if (x_move >= JOYRANGE_RIGHT_VALUE)
			nData |= MRIGHT;

				if(nData & MOK){
					sprintf(seldsk,DSKPATHV,ndsk[select]);
 					strcpy(CPC.drvA_path, DSKPATHV);
            				strcpy(CPC.drvA_file, ndsk[select]);
            				CPC.drvA_zip = 0;

					if (DBG) {
      						audio_resume();
   					}

					return (char*)seldsk;
				}
				if(nData & MUP && select>0 && (padcountdown==0) ){

					select--;
					if(fselect>0)fselect--;

					if(pad_held_down++<4) padcountdown=10;
					else padcountdown = 2;

					if(select<pselect)pselect--;
				}
				if(nData & MDOWN && select!=(ndsknum-1) && (padcountdown==0)  ){

					select++;
					if(fselect<9)fselect++;

					if(pad_held_down++<4) padcountdown=10;
					else padcountdown=2;

					if(select> (pselect+9) )pselect++;
				}
				if(nData & MLEFT && pselect>10 && (padcountdown==0) ){

					pselect-=10;
					select-=10;	

					if(pad_held_down++<4) padcountdown=10;
					else padcountdown = 2;
				}
				if(nData & MRIGHT && pselect < (ndsknum-16) && (padcountdown==0) ){

					pselect+=10;
					select+=10;

					if(pad_held_down++<4) padcountdown=10;
					else padcountdown = 2;					
				}

				if(!(nData & MUP) && !(nData & MDOWN)) pad_held_down = 0;


		SDL_FillRect(gui_surface, NULL, 0x00000000);

		drawrect(DECX-2,134-2,DECX+200+104+2,134+232+4,SDL_MapRGBA(gui_surface->format,0x7D, 0x79, 0xff,0x79) );
		putrect(DECX,134,SDL_MapRGBA(gui_surface->format,0x43, 0x8b, 0xff,0x45),200+104,232);


		for(i = pselect; i < (pselect + 10) ; i++){
			if(i<ndsknum){
				if( fselect == (i-pselect) ){					
					textpixel(DECX+8,150+(i-pselect)*20,0xffffffff,1,1,ndsk[i]);					
				}							
				else textpixel(DECX+8,150+(i-pselect)*20,0xff000000,1,1,ndsk[i]);	
							
			}	
		}
		


		SDL_BlitSurface(gui_surface, NULL, video_surface, NULL);
	   	SDL_Flip(video_surface);


    }

}

