#include <SDL/SDL.h>
#include <math.h>
#include <stdarg.h>	

#include "fontmsx.c"

//extern unsigned char  msx[]; //font lol

extern SDL_Surface *gui_surface ;
  
void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}

        
void printch(int x, int y, unsigned couleur,unsigned char ch,int taille,int pl) {

    int i,j;
    unsigned char *font;
    int rectx,recty;

    font=&msx[(int)ch * 8];

    for(i=0;i<8;i++,font++) {
        for(j=0;j<8;j++) {
            if ((*font &(128>>j))) {
                rectx = x+(j<<0);
                if(taille==1)
                    recty = y+(i<<1);
                else
                    recty = y+(i<<0);
             
                   putpixel( gui_surface, rectx, recty,couleur);
                if(pl==1)
                   putpixel( gui_surface, rectx,(recty+1),couleur);

            }
        }
    }
}

void textpixel(int x,int y,Uint32 color,int tail,int plein,const char *string,...)
{
   int boucle=0;  
   char	text[256];	   	
   va_list	ap;			
   
   if (string == NULL)return;		
		
   va_start(ap, string);		
      vsprintf(text, string, ap);	
   va_end(ap);	
   
   while(text[boucle]!=0){
     printch(x,y,color,text[boucle],tail,plein);
     boucle++;x+=8;//16;
   }
	
}

void printxy(int x,int y,Uint32 color,char *cad,int tail,int plein)
{
 while(cad[0]!=0){printch(x,y,color,cad[0],tail,plein);cad++;x+=16;}
}


void putrect(int xx,int yy,Uint32 col,int w,int h)
{ //lame putrec :(
      SDL_Rect rect;      
      rect.w = w;
      rect.h = h;
      rect.x = xx;
      rect.y = yy;      
      SDL_FillRect (gui_surface, &rect, col);          
} 

void drawrect(int x1,int y1,int x2,int y2,Uint32 coul)
{ //lame draw empty rect   !
 int tmp,i;
 if(x1>x2){tmp=x2;x2=x1;x1=tmp;}
 if(y1>y2){tmp=y2;y2=y1;y1=tmp;}
 
 for(i=x1;i<x1+(x2-x1);i++){
   putrect(i,y1,coul,1,1);
   putrect(i,y2,coul,1,1);
 }
 for(i=y1;i<y1+(y2-y1);i++){
   putrect(x1,i,coul,1,1);
   putrect(x2,i,coul,1,1);
 } 
 
}

