#define SDLK_LAST 512

/* SDL scancode key to cpc scan code mapping table */
static const char SDLKeyToCpcScanCode[SDLK_LAST] =
{
 	0xff,	/* 0 = SDL_SCANCODE_UNKNOWN */
 	0xff,	/* 1 = */
 	0xff,	/* 2 = */
 	0xff,	/* 3 = */
 	0x85,  /* SDLK_a = 97 */
	0x66,  /* SDLK_b = 98 */
	0x76,  /* SDLK_c = 99 */
	0x75,  /* SDLK_d = 100 */
	0x72,  /* SDLK_e = 101 */
	0x65,  /* SDLK_f = 102 */
	0x64,  /* SDLK_g = 103 */
	0x54,  /* SDLK_h = 104 */
	0x43,  /* SDLK_i = 105 */
	0x55,  /* SDLK_j = 106 */
	0x45,  /* SDLK_k = 107 */
	0x44,  /* SDLK_l = 108 */
	0x46,  /* SDLK_m = 109 */
	0x56,  /* SDLK_n = 110 */
	0x42,  /* SDLK_o = 111 */
	0x33,  /* SDLK_p = 112 */
	0x83,  /* SDLK_q = 113 */
	0x62,  /* SDLK_r = 114 */
	0x74,  /* SDLK_s = 115 */
	0x63,  /* SDLK_t = 116 */
	0x52,  /* SDLK_u = 117 */
	0x67,  /* SDLK_v = 118 */
	0x73,  /* SDLK_w = 119 */
	0x77,  /* SDLK_x = 120 */
	0x53,  /* SDLK_y = 121 */
	0x87,  /* SDLK_z = 122 */
 	0x80,	/* 30 = SDL_SCANCODE_1*/
 	0x81,	/* 31 = */
 	0x71,	/* 32 = */
 	0x70,	/* 33 = */
 	0x61,	/* 34 = */
 	0x60,	/* 35 = */
 	0x51,	/* 36 = */
 	0x50,	/* 37 = */
 	0x41,	/* 38 = SDL_SCANCODE_9*/
 	0x40,	/* 39 = SDL_SCANCODE_0*/
 	0x22,	/* 40 = RETURN*/
 	0x82,	/* 41 = ESCAPE*/
 	0x97,	/* 42 = BACKSPACE*/
 	0x84,	/* 43 = TAB*/
 	0x57,	/* 44 = SPACE*/
 	0x31,	/* 45 = MINUS*/
 	0x30,	/* 46 = EQUALS*/
 	0x32,	/* 47 = LEFTBRACKET*/
 	0x21,	/* 48 = RIGHTBRACKET*/
 	0x23,	/* 49 = BACKSLASH*/
 	0xff,	/* 50 = NONUSHASH*/
 	0x35,	/* 51 = SEMICOLON*/
 	0xff,	/* 52 = APOSTROPHE*/
 	0xff,	/* 53 = GRAVE*/
 	0x47,	/* 54 = COMMA*/
 	0x37,	/* 55 = PERIOD*/
 	0x36,	/* 56 = SLASH*/
 	0x86,	/* 57 = CAPSLOCK*/
	0xff,    /* SDLK_F1 = 282 */
	0xff,    /* SDLK_F2 = 283 */
	0xff,    /* SDLK_F3 = 284 */
	0xff,    /* SDLK_F4 = 285 */
	0xff,    /* SDLK_F5 = 286 */
	0xff,    /* SDLK_F6 = 287 */
	0xff,    /* SDLK_F7 = 288 */
	0xff,    /* SDLK_F8 = 289 */
	0xff,    /* SDLK_F9 = 290 */
	0xff,    /* SDLK_F10 = 291 */
	0xff,      /* SDLK_F11 = 292 */
	0xff,      /* SDLK_F12 = 293 */
 	0xff,	/* 70 = PRINTSCREEN*/
 	0xff,	/* 71 = SCROLLLOCK*/
 	0xff,	/* 72 = PAUSE*/
 	0x20,	/* 73 = INSERT*/
 	0xff,	/* 74 = HOME*/
 	0xff,	/* 75 = PAGEUP*/
 	0xff,	/* 76 = DELETE*/
 	0xff,	/* 77 = END*/
 	0xff,	/* 78 = PAGEDOWN*/
 	0x01,	/* 79 = RIGHT*/
 	0x10,	/* 80 = LEFT*/
 	0x02,	/* 81 = DOWN*/
 	0x00,	/* 82 = UP*/
 	0xff,	/* 83 = NUMLOCKCLEAR*/
 	0xff,	/* 84 = KP_DIVIDE*/
 	0xff,	/* 85 = KP_MULTIPLY*/
 	0xff,	/* 86 = KP_MINUS*/
 	0xff,	/* 87 = KP_PLUS*/
 	0x06,	/* 88 = KP_ENTER*/
 	0x15,	/* 89 = KP_1*/
 	0x16,	/* 90 = */
 	0x05,	/* 91 = */
 	0x24,	/* 92 = */
 	0x14,	/* 93 = */
 	0x04,	/* 94 = */
 	0x12,	/* 95 = */
 	0x13,	/* 96 = */
 	0x03,	/* 97 = KP_9*/
 	0x17,	/* 98 = KP_0*/
 	0x07,	/* 99 = KP_PERIOD*/
 	0xff,	/* 100 = NONUSBACKSLASH*/
 	0xff,	/* 101 = APPLICATION*/
 	0xff,	/* 102 = POWER*/
 	0xff,	/* 103 = KP_EQUALS*/
 	0xff,	/* 104 = F13 */
 	0xff,	/* 105 = */
 	0xff,	/* 106 = */
 	0xff,	/* 107 = */
 	0xff,	/* 108 = */
 	0xff,	/* 109 = */
 	0xff,	/* 110 = */
 	0xff,	/* 111 = */
 	0xff,	/* 112 = */
 	0xff,	/* 113 = */
 	0xff,	/* 114 = */
 	0xff,	/* 115 = F24*/
 	0xff,	/* 116 = EXECUTE*/
 	0xff,	/* 117 = HELP*/
 	0xff,	/* 118 = MENU*/
 	0xff,	/* 119 = SELECT*/
 	0xff,	/* 120 = STOP*/
 	0xff,	/* 121 = AGAIN*/
 	0xff,	/* 122 = UNDO*/
 	0xff,	/* 123 = CUT*/
 	0xff,	/* 124 = COPY*/
 	0xff,	/* 125 = PASTE*/
 	0xff,	/* 126 = FIND*/
 	0xff,	/* 127 = MUTE*/
 	0xff,	/* 128 = VOLUMEUP*/
 	0xff,	/* 129 = VOLUMEDOWN*/
 	0xff,	/* 130 = */
 	0xff,	/* 131 = */
 	0xff,	/* 132 = */
 	0xff,	/* 133 = KP_COMMA*/
 	0xff,	/* 134 = KP_EQUALSAS400*/
 	0xff,	/* 135 = INTERNATIONAL1*/
 	0xff,	/* 136 = */
 	0xff,	/* 137 = */
 	0xff,	/* 138 = */
 	0xff,	/* 139 = */
 	0xff,	/* 140 = */
 	0xff,	/* 141 = */
 	0xff,	/* 142 = */
 	0xff,	/* 143 = INTERNATIONAL9*/
 	0xff,	/* 144 = LANG1 */
 	0xff,	/* 145 = */
 	0xff,	/* 146 = */
 	0xff,	/* 147 = */
 	0xff,	/* 148 = */
 	0xff,	/* 149 = */
 	0xff,	/* 150 = */
 	0xff,	/* 151 = */
 	0xff,	/* 152 = LANG9*/
 	0xff,	/* 153 = ALTERASE*/
 	0xff,	/* 154 = SYSREQ*/
 	0xff,	/* 155 = CANCEL*/
 	0xff,	/* 156 = CLEAR*/
 	0xff,	/* 157 = PRIOR*/
 	0xff,	/* 158 = RETURN2*/
 	0xff,	/* 159 = SEPARATOR*/
 	0xff,	/* 160 = OUT*/
 	0xff,	/* 161 = OPER*/
 	0xff,	/* 162 = CLEARAGAIN*/
 	0xff,	/* 163 = CRSEL*/
 	0xff,	/* 164 = EXSEL*/
 	0xff,	/* 165 = */
 	0xff,	/* 166 = */
 	0xff,	/* 167 = */
 	0xff,	/* 168 = */
 	0xff,	/* 169 = */
 	0xff,	/* 170 = */
 	0xff,	/* 171 = */
 	0xff,	/* 172 = */
 	0xff,	/* 173 = */
 	0xff,	/* 174 = */
 	0xff,	/* 175 = */
 	0xff,	/* 176 = */
 	0xff,	/* 177 = */
 	0xff,	/* 178 = */
 	0xff,	/* 179 = */
 	0xff,	/* 180 = */
 	0xff,	/* 181 = */
 	0xff,	/* 182 = */
 	0xff,	/* 183 = */
 	0xff,	/* 184 = */
 	0xff,	/* 185 = */
 	0xff,	/* 186 = */
 	0xff,	/* 187 = */
 	0xff,	/* 188 = */
 	0xff,	/* 189 = */
 	0xff,	/* 190 = */
 	0xff,	/* 191 = */
 	0xff,	/* 192 = */
 	0xff,	/* 193 = */
 	0xff,	/* 194 = */
 	0xff,	/* 195 = */
 	0xff,	/* 196 = */
 	0xff,	/* 197 = */
 	0xff,	/* 198 = */
 	0xff,	/* 199 = */
 	0xff,	/* 200 = */
 	0xff,	/* 201 = */
 	0xff,	/* 202 = */
 	0xff,	/* 203 = */
 	0xff,	/* 204 = */
 	0xff,	/* 205 = */
 	0xff,	/* 206 = */
 	0xff,	/* 207 = */
 	0xff,	/* 208 = */
 	0xff,	/* 209 = */
 	0xff,	/* 210 = */
 	0xff,	/* 211 = */
 	0xff,	/* 212 = */
 	0xff,	/* 213 = */
 	0xff,	/* 214 = */
 	0xff,	/* 215 = */
 	0xff,	/* 216 = */
 	0xff,	/* 217 = */
 	0xff,	/* 218 = */
 	0xff,	/* 219 = */
 	0xff,	/* 220 = */
 	0xff,	/* 221 = */
 	0xff,	/* 222 = */
 	0xff,	/* 223 = */
 	0x27,	/* 224 = LCTRL*/
 	0x25,	/* 225 = LSHIFT*/
 	0x11,	/* 226 = LALT*/
 	0xff,	/* 227 = LGUI*/
 	0xff,	/* 228 = RCTRL*/
 	0x25,	/* 229 = RSHIFT*/
 	0x26,	/* 230 = RALT*/
 	0xff,	/* 231 = RGUI*/
 	0xff,	/* 232 = */
 	0xff,	/* 233 = */
 	0xff,	/* 234 = */
 	0xff,	/* 235 = */
 	0xff,	/* 236 = */
 	0xff,	/* 237 = */
 	0xff,	/* 238 = */
 	0xff,	/* 239 = */
 	0xff,	/* 240 = */
 	0xff,	/* 241 = */
 	0xff,	/* 242 = */
 	0xff,	/* 243 = */
 	0xff,	/* 244 = */
 	0xff,	/* 245 = */
 	0xff,	/* 246 = */
 	0xff,	/* 247 = */
 	0xff,	/* 248 = */
 	0xff,	/* 249 = */
 	0xff,	/* 250 = */
 	0xff,	/* 251 = */
 	0xff,	/* 252 = */
 	0xff,	/* 253 = */
 	0xff,	/* 254 = */
 	0xff,	/* 255 = */
 	0xff,	/* 256 = */
 	0xff,	/* 257 = */
 	0xff,	/* 258 = */
 	0xff,	/* 259 = */
 	0xff,	/* 260 = */
 	0xff,	/* 261 = */
 	0xff,	/* 262 = */
 	0xff,	/* 263 = */
 	0xff,	/* 264 = */
 	0xff,	/* 265 = */
 	0xff,	/* 266 = */
 	0xff,	/* 267 = */
 	0xff,	/* 268 = */
 	0xff,	/* 269 = */
 	0xff,	/* 270 = */
 	0xff,	/* 271 = */
 	0xff,	/* 272 = */
 	0xff,	/* 273 = */
 	0xff,	/* 274 = */
 	0xff,	/* 275 = */
 	0xff,	/* 276 = */
 	0xff,	/* 277 = */
 	0xff,	/* 278 = */
 	0xff,	/* 279 = */
 	0xff,	/* 280 = */
 	0xff,	/* 281 = */
 	0xff,	/* 282 = */
 	0xff,	/* 283 = */
 	0xff,	/* 284 = */
 	0xff,	/* 285 = */
 	0xff,	/* 286 = */
 	0xff,	/* 287 = */
 	0xff,	/* 288 = */
 	0xff,	/* 289 = */
 	0xff,	/* 290 = */
 	0xff,	/* 291 = */
 	0xff,	/* 292 = */
 	0xff,	/* 293 = */
 	0xff,	/* 294 = */
 	0xff,	/* 295 = */
 	0xff,	/* 296 = */
 	0xff,	/* 297 = */
 	0xff,	/* 298 = */
 	0xff,	/* 299 = */
 	0xff,	/* 300 = */
 	0xff,	/* 301 = */
 	0xff,	/* 302 = */
 	0xff,	/* 303 = */
 	0xff,	/* 304 = */
 	0xff,	/* 305 = */
 	0xff,	/* 306 = */
 	0xff,	/* 307 = */
 	0xff,	/* 308 = */
 	0xff,	/* 309 = */
 	0xff,	/* 310 = */
 	0xff,	/* 311 = */
 	0xff,	/* 312 = */
 	0xff,	/* 313 = */
 	0xff,	/* 314 = */
 	0xff,	/* 315 = */
 	0xff,	/* 316 = */
 	0xff,	/* 317 = */
 	0xff,	/* 318 = */
 	0xff,	/* 319 = */
 	0xff,	/* 320 = */
 	0xff,	/* 321 = */
 	0xff,	/* 322 = */
 	0xff,	/* 323 = */
 	0xff,	/* 324 = */
 	0xff,	/* 325 = */
 	0xff,	/* 326 = */
 	0xff,	/* 327 = */
 	0xff,	/* 328 = */
 	0xff,	/* 329 = */
 	0xff,	/* 330 = */
 	0xff,	/* 331 = */
 	0xff,	/* 332 = */
 	0xff,	/* 333 = */
 	0xff,	/* 334 = */
 	0xff,	/* 335 = */
 	0xff,	/* 336 = */
 	0xff,	/* 337 = */
 	0xff,	/* 338 = */
 	0xff,	/* 339 = */
 	0xff,	/* 340 = */
 	0xff,	/* 341 = */
 	0xff,	/* 342 = */
 	0xff,	/* 343 = */
 	0xff,	/* 344 = */
 	0xff,	/* 345 = */
 	0xff,	/* 346 = */
 	0xff,	/* 347 = */
 	0xff,	/* 348 = */
 	0xff,	/* 349 = */
 	0xff,	/* 350 = */
 	0xff,	/* 351 = */
 	0xff,	/* 352 = */
 	0xff,	/* 353 = */
 	0xff,	/* 354 = */
 	0xff,	/* 355 = */
 	0xff,	/* 356 = */
 	0xff,	/* 357 = */
 	0xff,	/* 358 = */
 	0xff,	/* 359 = */
 	0xff,	/* 360 = */
 	0xff,	/* 361 = */
 	0xff,	/* 362 = */
 	0xff,	/* 363 = */
 	0xff,	/* 364 = */
 	0xff,	/* 365 = */
 	0xff,	/* 366 = */
 	0xff,	/* 367 = */
 	0xff,	/* 368 = */
 	0xff,	/* 369 = */
 	0xff,	/* 370 = */
 	0xff,	/* 371 = */
 	0xff,	/* 372 = */
 	0xff,	/* 373 = */
 	0xff,	/* 374 = */
 	0xff,	/* 375 = */
 	0xff,	/* 376 = */
 	0xff,	/* 377 = */
 	0xff,	/* 378 = */
 	0xff,	/* 379 = */
 	0xff,	/* 380 = */
 	0xff,	/* 381 = */
 	0xff,	/* 382 = */
 	0xff,	/* 383 = */
 	0xff,	/* 384 = */
 	0xff,	/* 385 = */
 	0xff,	/* 386 = */
 	0xff,	/* 387 = */
 	0xff,	/* 388 = */
 	0xff,	/* 389 = */
 	0xff,	/* 390 = */
 	0xff,	/* 391 = */
 	0xff,	/* 392 = */
 	0xff,	/* 393 = */
 	0xff,	/* 394 = */
 	0xff,	/* 395 = */
 	0xff,	/* 396 = */
 	0xff,	/* 397 = */
 	0xff,	/* 398 = */
 	0xff,	/* 399 = */
 	0xff,	/* 400 = */
 	0xff,	/* 401 = */
 	0xff,	/* 402 = */
 	0xff,	/* 403 = */
 	0xff,	/* 404 = */
 	0xff,	/* 405 = */
 	0xff,	/* 406 = */
 	0xff,	/* 407 = */
 	0xff,	/* 408 = */
 	0xff,	/* 409 = */
 	0xff,	/* 410 = */
 	0xff,	/* 411 = */
 	0xff,	/* 412 = */
 	0xff,	/* 413 = */
 	0xff,	/* 414 = */
 	0xff,	/* 415 = */
 	0xff,	/* 416 = */
 	0xff,	/* 417 = */
 	0xff,	/* 418 = */
 	0xff,	/* 419 = */
 	0xff,	/* 420 = */
 	0xff,	/* 421 = */
 	0xff,	/* 422 = */
 	0xff,	/* 423 = */
 	0xff,	/* 424 = */
 	0xff,	/* 425 = */
 	0xff,	/* 426 = */
 	0xff,	/* 427 = */
 	0xff,	/* 428 = */
 	0xff,	/* 429 = */
 	0xff,	/* 430 = */
 	0xff,	/* 431 = */
 	0xff,	/* 432 = */
 	0xff,	/* 433 = */
 	0xff,	/* 434 = */
 	0xff,	/* 435 = */
 	0xff,	/* 436 = */
 	0xff,	/* 437 = */
 	0xff,	/* 438 = */
 	0xff,	/* 439 = */
 	0xff,	/* 440 = */
 	0xff,	/* 441 = */
 	0xff,	/* 442 = */
 	0xff,	/* 443 = */
 	0xff,	/* 444 = */
 	0xff,	/* 445 = */
 	0xff,	/* 446 = */
 	0xff,	/* 447 = */
 	0xff,	/* 448 = */
 	0xff,	/* 449 = */
 	0xff,	/* 450 = */
 	0xff,	/* 451 = */
 	0xff,	/* 452 = */
 	0xff,	/* 453 = */
 	0xff,	/* 454 = */
 	0xff,	/* 455 = */
 	0xff,	/* 456 = */
 	0xff,	/* 457 = */
 	0xff,	/* 458 = */
 	0xff,	/* 459 = */
 	0xff,	/* 460 = */
 	0xff,	/* 461 = */
 	0xff,	/* 462 = */
 	0xff,	/* 463 = */
 	0xff,	/* 464 = */
 	0xff,	/* 465 = */
 	0xff,	/* 466 = */
 	0xff,	/* 467 = */
 	0xff,	/* 468 = */
 	0xff,	/* 469 = */
 	0xff,	/* 470 = */
 	0xff,	/* 471 = */
 	0xff,	/* 472 = */
 	0xff,	/* 473 = */
 	0xff,	/* 474 = */
 	0xff,	/* 475 = */
 	0xff,	/* 476 = */
 	0xff,	/* 477 = */
 	0xff,	/* 478 = */
 	0xff,	/* 479 = */
 	0xff,	/* 480 = */
 	0xff,	/* 481 = */
 	0xff,	/* 482 = */
 	0xff,	/* 483 = */
 	0xff,	/* 484 = */
 	0xff,	/* 485 = */
 	0xff,	/* 486 = */
 	0xff,	/* 487 = */
 	0xff,	/* 488 = */
 	0xff,	/* 489 = */
 	0xff,	/* 490 = */
 	0xff,	/* 491 = */
 	0xff,	/* 492 = */
 	0xff,	/* 493 = */
 	0xff,	/* 494 = */
 	0xff,	/* 495 = */
 	0xff,	/* 496 = */
 	0xff,	/* 497 = */
 	0xff,	/* 498 = */
 	0xff,	/* 499 = */
 	0xff,	/* 500 = */
 	0xff,	/* 501 = */
 	0xff,	/* 502 = */
 	0xff,	/* 503 = */
 	0xff,	/* 504 = */
 	0xff,	/* 505 = */
 	0xff,	/* 506 = */
 	0xff,	/* 507 = */
 	0xff,	/* 508 = */
 	0xff,	/* 509 = */
 	0xff,	/* 510 = */
 	0xff,	/* 511 = */
};

